// JavaScript Document
function resourcesManager(game){
	this.funcCall=false;
	this.objCall=false;
	this.show=false;
	this.Data={
		Images:{},
		Files:{},
		Sounds:{}
	}
	this.queue={
		Images:[],
		Files:[],
		Sounds:[]
	}
	this.queueStart={
		Images:[],
		Files:[],
		Sounds:[]
	}
	this.fileCount=0;
	this.filesLoaded=0;
	
	this.queueEmpty=queueEmpty;function queueEmpty(src){
//		console.log(src+' '+this.queue.Images.length+' '+this.queue.Files.length+' '+this.queue.Sounds.length);
		if(this.queue.Images.length || this.queue.Files.length || this.queue.Sounds.length){if(src)console.log('resources loading pending, loading of "'+src+'" failed');return(false);}
		return(true);
	}
	
	this.LoadFile=LoadFile;function LoadFile(id,src){
		if(!this.queueEmpty(src))return(false);
		var str='';
  		var xmlHttp=GetXmlHttpObject();if (xmlHttp==null){alert ("Your browser does not support AJAX!");return;}
//  		xmlHttp.abort();
		xmlHttp.manager=this;
  		xmlHttp.onreadystatechange=function(){
    		if(xmlHttp.readyState==4){
				var i;
				i=this.manager.queue.Files.indexOf(id);
				if(i>=0)this.manager.queue.Files.splice(i,1);
				i=this.manager.queueStart.Files.indexOf(id);
				if(i>=0)this.manager.queueStart.Files.splice(i,1);
				if(this.manager.Data.Files[id])this.manager.Data.Files[id]=null;
		        this.manager.Data.Files[id]=unescape(xmlHttp.responseText);
				this.manager.filesLoaded++;
		    }
		  }
		  xmlHttp.open("GET",src,true);
		  this.queueStart.Files.push(id);
		  xmlHttp.send(null);
	}
	
	
	this.LoadSound=LoadSound;function LoadSound(id,src_mp3,src_ogg){
		if(!this.queueEmpty(src_mp3))return(false);
		if(this.Data.Sounds[id])this.Data.Sounds[id]=null;
		this.Data.Sounds[id]=new Caudio();
		this.Data.Sounds[id].LoadSound(src_mp3,src_ogg);
		this.queueStart.Sounds.push(id);
	}
	
	this.LoadImage=LoadImage;function LoadImage(id,src){
		var i;
		if(!this.queueEmpty(src))return(false);
		if(this.Data.Images[id])this.Data.Images[id]=null;
		this.Data.Images[id]=new Image();
		this.Data.Images[id].loaded=false;
		this.Data.Images[id].manager=this;
		this.Data.Images[id].onload=function(){
			this.loaded=true;
			i=this.manager.queue.Images.indexOf(this.src);
			if(i>=0)this.manager.queue.Images.splice(i,1);
			i=this.manager.queueStart.Images.indexOf(this.src);
			if(i>=0)this.manager.queueStart.Images.splice(i,1);
			this.manager.filesLoaded++;
		}
		this.Data.Images[id].src=src;
		this.queueStart.Images.push(this.Data.Images[id].src);
	}
	
	this.Start=Start;function Start(functionCall,obj){
		var i;
		this.queue=this.queueStart;
		this.queueStart={
			Images:[],
			Files:[],
			Sounds:[]
		}
		this.funcCall=functionCall;
		this.objCall=obj;
		this.fileCount=this.queue.Images.length+this.queue.Sounds.length+this.queue.Files.length;
		this.filesLoaded=0;
		this.show=true;
	}
	
	this.Run=Run;function Run(){
		if(!this.show)return;
		var i;
		for(i=0;i<this.queue.Sounds.length;i++)if(this.Data.Sounds[this.queue.Sounds[i]].ready()){this.queue.Sounds.splice(i,1);i=0;this.filesLoaded++;}
		if(this.queueEmpty()){
			game.UI.drawLoading(this.fileCount,this.fileCount);
			this.show=false;
			var func=eval(this.funcCall);
			if(!this.objCall)this.objCall=this;
			if(func)func.call(this.objCall);
			return;
		}
//		console.log(this.filesLoaded+' / '+this.fileCount);
		//drawing the loading screen (should be on top of everything else, if stuff needs to pause while this is going, set a flag to mark that a load is in progress)
		if(game && game.UI){
			game.UI.drawLoading(this.filesLoaded,this.fileCount);
		}
	}
}