// JavaScript Document
function Caudio(){
	this.Load=function(){
		this.sound=document.createElement('audio');
		this.sound.UsrParent=this;
		this.canplay=false;
		this.meta=false;
		this.Ready=false;
		this.playing=false;
		this.failed=false;
		this.sound.addEventListener("error", SoundError, true);
		this.sound.addEventListener("pause", SoundPause, true);
		//this.sound.addEventListener('canplaythrough', SoundCanPlay, false);
		this.sound.oncanplay=this.setReady();//addEventListener("canplay", function(){alert('??');},true);
	}
	
	
	this.setReady=setReady;function setReady(){
		if(!this.failed){
			if(this.sound)
				this.sound.readyState=4;
		}
		this.Ready=true;
	}
	
	this.ready=ready;function ready(){
		if(this.Ready)return(true);
		if(this.failed){
			this.Ready=true;
		}
		if(this.sound.readyState>=4){
			if(this.PlayThrough){this.sound.volume=1.0;}
			this.canplay=true;
			this.Ready=true;
			return(true);
		}
		if(navigator.appName != 'Microsoft Internet Explorer')//do not start the sound in IE
		if(this.sound.readyState>=2 && !this.canplay){
			this.sound.volume=0.001;
			this.sound.muted=true;
			this.sound.play();
		}
		return(false);
	}

	function SoundCanPlay(){
		this.readyState=2;
		this.Ready=true;
		if(this.UsrParent)this.UsrParent.Ready=true;
		if(navigator.appName != 'Microsoft Internet Explorer'){//do not start the sound in IE
			this.volume=0.001;
			this.muted=true;
			this.play();
		}
	}

	function SoundError(){
		this.UsrParent.failed=true;
		this.failed=true;
		console.log('Error while sound '+this+' was in stage "'+this.error+'" !');
	}
	
	function SoundPause(){
		this.UsrParent.playing=false;
		this.playing=false;
	}
	
	this.LoadSound=LoadSound;function LoadSound(sound_mp3,sound_ogg,messages){
		this.canplay=false;
		this.failed=false;
		this.Ready=false;
		this.PlayThrough=false;
		if(isMobileSafari()){
			this.failed=true;
			return;
		}
		if(this.sound.canPlayType){
			this.sound.preload='auto';
			if(this.sound.canPlayType('audio/ogg'))this.sound.src=sound_ogg;
			else if(this.sound.canPlayType('audio/mp3'))this.sound.src=sound_mp3;
			else this.failed=true;
		}else this.failed=true;
		if(this.sound.load)this.sound.load();
	}
	
	this.getPos=getPos;function getPos(){
		if(this.failed)return(0);
		return(this.sound.currentTime);
	}
	
	this.getDuration=getDuration;function getDuration(){
		if(this.failed)return(0);
		return(this.sound.duration);
	}
	
	this.Play=Play;function Play(time){
		if(this.failed)return;
		if(typeof game !== 'undefined' && game.soundOn===false)return;
		if(!time)time=0;
		if(this.sound.currentTime!=time)
			this.sound.currentTime=time;
		this.sound.muted=false;
		this.playing=true;
		this.sound.volume=1.0;
		this.sound.play();
	}
	this.Stop=Stop;function Stop(){
		if(this.failed)return;
		this.sound.currentTime=0;
		this.sound.muted=false;
		this.playing=false;
		this.sound.volume=1.0;
		this.sound.pause();
	}
	this.Load();
}

function isMobileSafari() {
    return navigator.userAgent.match(/(iPod|iPhone|iPad)/) && navigator.userAgent.match(/AppleWebKit/)
}