// JavaScript Document
function Cmplayer(game,player,lane){
	this.type='MP';
	this.car=new Ccar(game,0,lane);
	this.position=0;
	this.crash=false;
	this.finished=false;
	this.ERR=0;
	this.WPM=0;
	this.lastTime=0;
	this.crashTime=0;
	this.finishTime=0;
	this.name=player.name;
	this.id=player.id;
	this.receivedReady=false;
	console.log('mplayer join:');
	console.log(player);
	var obj=document.getElementById('lobbyLane_'+lane);
	if(player.country){
		game.carDescript[lane]='&nbsp;&nbsp;&nbsp;';
		game.carDescript[lane]+='<img align="absmiddle" width="'+(40)+'" src="'+player.country.flagIconUrl+'" />&nbsp;&nbsp;';
		game.carDescript[lane]+=player.name;
	}else
		game.carDescript[lane]='<div style="margin-top:'+(2*game.UI.scaleVal)+'px;margin-left:'+(66*game.UI.scaleVal)+'px">'+player.name+'</div>';
	if(obj)obj.innerHTML=game.carDescript[lane];
	
	
	this.ready=ready;function ready(){
		if(player.rand=="V")this.receivedReady=true;
		if(!this.receivedReady)return(false);
		this.car.goToStart();
		if(this.car.ready)return(true);
		return(false);
	}
	
	this.setPosition=setPosition;function setPosition(pos,wpm,time){
		var position=parseInt(pos);
		if(this.position>position)return;
		this.position=position;
		this.WPM=parseFloat(wpm);
		var key=game.sentence[this.position-1];
		console.log('setting position for car '+lane+' to : '+pos+'; last key: '+key);
		if(key==' ' || key=='.' || key==',' || key==';' || this.position>=game.sentence.length){
			this.car.position=this.position*game.config.gameSettings.settings.letterTrackSize;
			if(this.position>=game.sentence.length){//end race
				this.finished=true;
				this.finishTime=time;
			}
			game.SFX.carMoves(lane);
		}
	}
	
	this.error=error;function error(time){
		this.ERR++;
		if(this.ERR>=game.config.gameSettings.difficulty[game.difficulty].errorsToCrash){
			this.ERR=game.config.gameSettings.difficulty[game.difficulty].errorsToCrash;
			this.crash=true;
			this.crashTime=time;
			console.log(' -crashed-');
		}else if(this.ERR==game.config.gameSettings.difficulty[game.difficulty].errorsToSmoke){
			console.log('smoking');
			game.SFX.addEffect('smoke_1',lane);
		}else if(this.ERR==game.config.gameSettings.difficulty[game.difficulty].errorsToFire){
			console.log('fire');
			game.SFX.addEffect('fire_1',lane);
		}
	}
	
	this.Run=Run;function Run(){
		if(!this.crash && !this.finished){this.WPM=(this.position*12000)/(game.time-game.raceTime);this.crashTime=this.finishTime=game.time;}
		if(this.finished && !this.crash)this.car.position+=game.config.gameSettings.settings.letterTrackSize;
		else if(this.crash)this.car.position-=game.config.gameSettings.settings.backgroundSpeed;
		else if(this.car.position>game.trackLength)this.car.position=game.trackLength;
		this.car.Run();
	}
	
	this.Draw=Draw;function Draw(){
		this.car.Draw();
	}
}